unit magische6Eck;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Spin;

const MaxGesetzt=19;

type
  TFeld=Array[1..5,1..5]of Integer;
  TSumme=Array[1..2,1..5]of Integer; // 1: Summe in einer Reihe
                                     // 2: Anzahl gesetzter Zahlen
  TZahlen=Set of 1..MaxGesetzt;

  Tmag6Eck = class(TForm)
    Ausgabe: TStringGrid;
    LabelX: TLabel;
    LabelY: TLabel;
    LabelZeit: TLabel;
    LabelV: TLabel;
    ZeilenIndex: TSpinEdit;
    SpaltenIndex: TSpinEdit;
    Start: TButton;
    LabelmZ: TLabel;
    LabelL: TLabel;
    function TimeSekunden:Extended;
    procedure InitZahlen(Var Z:TZahlen);
    procedure InitSumme(Var S:TSumme);
    procedure InitFeld(Var F:TFeld);
    procedure Summiere(Var S1,S2,S3:TSumme);
    function Brauchbar:Boolean;
    function Fertig:Boolean;
    procedure naechstesFeld(x,y:Integer;Var XNeu,YNeu:Integer);
    procedure Versuche(x,y:Integer);
    procedure StartClick(Sender: TObject);
    procedure Ausgeben;
  private
    { Private-Deklarationen }
    Feld:TFeld;
    Zahlen:TZAhlen;
    Versuch:Int64;
    Gesetzt,Gesamt:Integer;
    Abbruch,Gefunden:Boolean;
    T_Sek:Extended;
  public
    { Public-Deklarationen }
  end;

var mag6Eck: Tmag6Eck;

implementation

{$R *.dfm}
{$R+,Q+}

 function Tmag6Eck.TimeSekunden:Extended;
  var H,M,S,MS:Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000; // Umrechnung in Sekunden
  end;

 procedure Tmag6Eck.InitZahlen(Var Z:TZahlen);
  begin Z:=[1..MaxGesetzt] end;

 procedure Tmag6Eck.InitSumme(Var S:TSumme);
  var x:Integer;
  begin
   for x:=1 to 5 do S[1,x]:=0;
   S[2,1]:=2; // nicht belegte Felder
   S[2,2]:=1;
   S[2,3]:=0;
   S[2,4]:=1;
   S[2,5]:=2;
  end;

 procedure Tmag6Eck.InitFeld(Var F:TFeld);
  var x,y:Integer;
  begin
   for x:=1 to 5 do
    for y:=1 to 5 do F[x,y]:=0;
   F[1,4]:=-1; // nicht belegte Felder sperren
   F[1,5]:=-1;
   F[2,5]:=-1;
   F[4,1]:=-1;
   F[5,1]:=-1;
   F[5,2]:=-1;
  end;

 procedure Tmag6Eck.Summiere(Var S1,S2,S3:TSumme);
  var x,y:Integer;
  begin
   for x:=1 to 5 do
    for y:=1 to 5 do
     if Feld[x,y]>0 then
      begin
       inc(S1[1,x],Feld[x,y]);inc(S1[2,x]);         // waagerecht
       inc(S2[1,y],Feld[x,y]);inc(S2[2,y]);         // senkrecht
       inc(S3[1,x-y+3],Feld[x,y]);inc(S3[2,x-y+3]); // diagonal
      end
  end;

 function Tmag6Eck.Brauchbar:Boolean;
  var x:Integer;
      Summe1,Summe2,Summe3:TSumme;
  begin
   Brauchbar:=False;
   InitSumme(Summe1);Summe2:=Summe1;Summe3:=Summe1;
   Summiere(Summe1,Summe2,Summe3);
   for x:=1 to 5 do
    if not(
     ((Summe1[1,x]=38) and (Summe1[2,x]=5) or
      (Summe1[2,x]=4) and (38-Summe1[1,x] in Zahlen) or
      (Summe1[1,x]<38) and (Summe1[2,x]<4)) and
     ((Summe2[1,x]=38) and (Summe2[2,x]=5) or
      (Summe2[2,x]=4) and (38-Summe2[1,x] in Zahlen) or
      (Summe2[1,x]<38) and (Summe2[2,x]<4)) and
     ((Summe3[1,x]=38) and (Summe3[2,x]=5) or
      (Summe3[2,x]=4) and (38-Summe3[1,x] in Zahlen) or
      (Summe3[1,x]<38) and (Summe3[2,x]<4))) then exit;
   Brauchbar:=True;
  end;

 function Tmag6Eck.Fertig:Boolean;
  var x:Integer;
      Summe1,Summe2,Summe3:TSumme;
  begin
   Fertig:=False;
   InitSumme(Summe1);Summe2:=Summe1;Summe3:=Summe1;
   Summiere(Summe1,Summe2,Summe3);
   for x:=1 to 5 do
    if (Summe1[1,x]<>38) or (Summe2[1,x]<>38) or (Summe3[1,x]<>38) then exit;
   Fertig:=True
  end;

 procedure Tmag6Eck.Ausgeben;
  var x,y:Integer;
  begin
   for x:=0 to 4 do
    for y:=0 to 4 do
     if Feld[x+1,y+1]>0 then
      Ausgabe.Cells[(2-y)+2*x,2*y]:=IntToStr(Feld[x+1,y+1]);
   Gefunden:=True;Inc(Gesamt);
   Screen.Cursor:=crDefault;
   LabelV.Caption:='Anzahl der Versuche = '+IntToStr(Versuch);
   T_Sek:=TimeSekunden-T_Sek;
   LabelZeit.Caption:='Rechenzeit= '+Format('%0.2f',[T_Sek])+' sek.';
   if MessageDlgPos('Weiter suchen?',mtConfirmation,[mbyes,mbNo],0,
                     mag6Eck.Left+28+Ausgabe.Width,mag6Eck.Top+
                                  Ausgabe.Top+80)=mrno then Abbruch:=True
   else Screen.Cursor:=crHourGlass;
   T_Sek:=TimeSekunden;
  end;

 procedure Tmag6Eck.naechstesFeld(x,y:Integer;Var XNeu,YNeu:Integer);
  // nchste mgliche Position bestimmen
  var x1,y1:Integer;
  begin
   for y1:=1 to 5 do  // 2. von oben nach unten
    for x1:=1 to 5 do // 1. von links nach rechts
     if Feld[x1,y1]=0 then begin XNeu:=x1;YNeu:=y1;exit end
  end;

 procedure Tmag6Eck.Versuche(x,y:Integer);
  var i,x1,y1:Integer;
  begin
   if Abbruch then exit;
   inc(Versuch);
   for i:=1 to MaxGesetzt do
    if i in Zahlen then
     begin
      // Zug ausfhren
      Zahlen:=Zahlen-[i];
      Feld[x,y]:=i;inc(Gesetzt);
      if (Gesetzt=MaxGesetzt) and Fertig then Ausgeben
      else
       if Brauchbar then
        begin
         naechstesFeld(x,y,x1,y1);
         Versuche(x1,y1);
        end;
      // Zug zurcknehmen
      Zahlen:=Zahlen+[i];
      Feld[x,y]:=0;dec(Gesetzt);
     end;
  end;

 procedure Tmag6Eck.StartClick(Sender: TObject);
  var X,Y,X1,Y1,Z,S:Integer;
  begin
   Gefunden:=False;Abbruch:=False;Versuch:=0;
   InitFeld(Feld);
   InitZahlen(Zahlen);
   X:=SpaltenIndex.Value;
   Y:=ZeilenIndex.Value;
   if Feld[X,Y]<>0 then
    begin
     MessageDlg('"Deine Wahl war schlecht!",sprach der letzte Kreuzritter.',mtError,[mbOk],0);
     exit
    end;
   LabelV.Caption:='Anzahl der Versuche= ';
   LabelV.Repaint;
   LabelZeit.Caption:='Rechenzeit= ';
   LabelZeit.Repaint;
   for Z:=0 to 9 do
    for S:=0 to 9 do
     Ausgabe.Cells[Z,S]:=' ';
   Ausgabe.Repaint;
   Zahlen:=Zahlen-[1];
   Feld[x,y]:=1;
   Gesetzt:=1;Gesamt:=0;
   LabelL.Caption:='Lsungen=';
   LabelL.Repaint;
   naechstesFeld(x,y,x1,y1);
   T_Sek:=TimeSekunden;
   Screen.Cursor:=crHourGlass;
   Versuche(x1,y1);
   Screen.Cursor:=crDefault;
   LabelL.Caption:='Lsungen='+IntToStr(Gesamt);
   if not Gefunden then
    begin
     T_Sek:=TimeSekunden-T_Sek;
     LabelZeit.Caption:='Rechenzeit= '+Format('%0.2f',[T_Sek])+
                        ' sek. Es gibt keine Lsung ';
     LabelV.Caption:='Anzahl der Versuche= '+IntToStr(Versuch);
    end;
  end;

end.

